diff --git a/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java
index bb083313d..13a77552e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/MapItemRenderer.java
@@ -3,9 +3,9 @@ package net.minecraft.client.render;
 import java.awt.image.BufferedImage;
 import java.util.Iterator;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.TextureBuffered;
 
-import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.util.helper.Color;
@@ -22,22 +22,15 @@ public class MapItemRenderer
 
     private final int[] mapImageData;
     private TextureBuffered mapTexture;
-    private final GameSettings gameSettings;
-    private final TextureManager textureManager;
-    private Font font;
 
-
-    public MapItemRenderer(Font font, GameSettings gamesettings, TextureManager textureManager)
+    public MapItemRenderer()
     {
         mapImageData = new int[IMAGE_AREA];
-        gameSettings = gamesettings;
-        this.textureManager = textureManager;
-        this.font = font;
     }
 
     public void preRender() {
         if (mapTexture == null) {
-            mapTexture = textureManager.loadBufferedTexture(new BufferedImage(128, 128, 2));
+            mapTexture = Minecraft.getMinecraft().textureManager.loadBufferedTexture(new BufferedImage(128, 128, 2));
             for(int i = 0; i < IMAGE_AREA; i++)
             {
                 mapImageData[i] = 0;
@@ -45,9 +38,10 @@ public class MapItemRenderer
         }
     }
 
-    public void renderMap(TextureManager textureManager, ItemMapSavedData data, float brightness)
+    public void renderMap(Tessellator tessellator, ItemMapSavedData data, float brightness)
     {
         preRender();
+        TextureManager textureManager = Minecraft.getMinecraft().textureManager;
         for(int i = 0; i < IMAGE_AREA; i++)
         {
             int colorIndex = data.colors[i];
@@ -85,17 +79,16 @@ public class MapItemRenderer
         textureManager.updateTextureData(mapImageData, 128, 128, mapTexture.id());
         int j = 0;
         int k = 0;
-        Tessellator tessellator = Tessellator.instance;
         float f = 0.0F;
         //renders the map
         mapTexture.bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glDisable(GL11.GL_ALPHA_TEST);
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV((float)(j + 0) + f, (float)(k + 128) - f, -0.01D, 0.0D, 1.0D);
+        tessellator.addVertexWithUV((float)(j) + f, (float)(k + 128) - f, -0.01D, 0.0D, 1.0D);
         tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 128) - f, -0.01D, 1.0D, 1.0D);
-        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 0) + f, -0.01D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV((float)(j + 0) + f, (float)(k + 0) + f, -0.01D, 0.0D, 0.0D);
+        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k) + f, -0.01D, 1.0D, 0.0D);
+        tessellator.addVertexWithUV((float)(j) + f, (float)(k) + f, -0.01D, 0.0D, 0.0D);
         tessellator.draw();
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glDisable(GL11.GL_BLEND);
@@ -105,7 +98,7 @@ public class MapItemRenderer
         {
             MapWaypoint mapWaypoint = iterator.next();
             GL11.glPushMatrix();
-            GL11.glTranslatef((float)j + (float)mapWaypoint.mapCoordX / 2.0F + 64F, (float)k + (float)mapWaypoint.mapCoordZ / 2.0F + 64F, -0.02F);
+            GL11.glTranslatef((float)j + (float)mapWaypoint.mapCoordX / 2.0F + 64, (float)k + (float)mapWaypoint.mapCoordZ / 2.0F + 64, -0.02F);
             GL11.glRotatef((float)(8 * 360) / 16F , 0.0F, 0.0F, 1.0F);
             GL11.glScalef(4F, 4F, 3F);
             GL11.glTranslatef(-0.125F, 0.125F, 0.0F);
@@ -127,7 +120,7 @@ public class MapItemRenderer
         {
             ItemMapSavedData.MapDecoration decoration = iterator.next();
             GL11.glPushMatrix();
-            GL11.glTranslatef((float)j + (float)decoration.x / 2.0F + 64F, (float)k + (float)decoration.y / 2.0F + 64F, -0.02F);
+            GL11.glTranslatef((float)j + (float)decoration.x / 2.0F + 64, (float)k + (float)decoration.y / 2.0F + 64, -0.02F);
             GL11.glRotatef((decoration.rot * 360F) / ItemMapSavedData.MapDecoration.ROTATION_STEPS, 0.0F, 0.0F, 1.0F);
             GL11.glScalef(4F, 4F, 3F);
             GL11.glTranslatef(-0.125F, 0.125F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 90cf78a48..03915e02f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -77,7 +77,6 @@ public class RenderGlobal
     private int renderChunksDeep;
     private int glRenderListBase;
     private final Minecraft mc;
-    private RenderBlocks globalRenderBlocks;
     private IntBuffer glOcclusionQueryBase;
     private boolean occlusionEnabled;
     private float lastCloudOffsetX = 0;
@@ -259,7 +258,6 @@ public class RenderGlobal
         EntityRenderDispatcher.instance.unloadEntityRenderers();
         EntityRenderDispatcher.instance.setWorld(world);
         worldObj = world;
-        globalRenderBlocks = new RenderBlocks(world);
         auroraBrightness = 0.0f;
         targetAuroraBrightness = Float.NaN;
         if(world != null)
@@ -467,7 +465,7 @@ public class RenderGlobal
             renderEntitiesStartupCounter--;
             return;
         }
-        BlockEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, partialTick);
+        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, partialTick);
         EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, mc.gameSettings, partialTick);
         countEntitiesTotal = 0;
         countEntitiesRendered = 0;
@@ -475,9 +473,9 @@ public class RenderGlobal
         EntityRenderDispatcher.renderPosX = camera.getX(partialTick);
         EntityRenderDispatcher.renderPosY = camera.getY(partialTick);
         EntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
-        BlockEntityRenderDispatcher.renderPosX = camera.getX(partialTick);
-        BlockEntityRenderDispatcher.renderPosY = camera.getY(partialTick);
-        BlockEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
+        TileEntityRenderDispatcher.renderPosX = camera.getX(partialTick);
+        TileEntityRenderDispatcher.renderPosY = camera.getY(partialTick);
+        TileEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
         List<Entity> loadedEntities = worldObj.getLoadedEntityList();
         countEntitiesTotal = loadedEntities.size();
         Tessellator tessellator = Tessellator.instance;
@@ -526,7 +524,7 @@ public class RenderGlobal
 
         for (TileEntity tileEntity : tileEntities)
         {
-            BlockEntityRenderDispatcher.instance.renderTileEntity(tessellator, tileEntity, partialTick);
+            TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, tileEntity, partialTick);
         }
     }
 
@@ -1381,16 +1379,15 @@ public class RenderGlobal
             	// Make sure it's active to prevent crash if a model doesnt enable it
             	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
             }
-            BlockModel.setRenderBlocks(globalRenderBlocks);
             BlockModelDispatcher.getInstance()
                 .getDispatch(block)
                 .renderWithOverrideTexture(
                     tessellator,
+                    worldObj,
                     hitResult.x,
                     hitResult.y,
                     hitResult.z,
-                    breakingAnimation[MathHelper.clamp((int)(damagePartialTime * 10F), 0, breakingAnimation.length - 1)]
-                );
+                    breakingAnimation[MathHelper.clamp((int)(damagePartialTime * 10F), 0, breakingAnimation.length - 1)]);
             tessellator.draw();
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             GL11.glDisable(GL11.GL_ALPHA_TEST);
diff --git a/game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
similarity index 95%
rename from game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
rename to game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index ff3db3266..06044da4e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -4,17 +4,17 @@ import java.util.*;
 
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.blockentity.*;
+import net.minecraft.client.render.tileentity.*;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.*;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
-public class BlockEntityRenderDispatcher
+public class TileEntityRenderDispatcher
 {
 
-    private BlockEntityRenderDispatcher()
+    private TileEntityRenderDispatcher()
     {
         renderers = new HashMap<>();
         renderers.put(TileEntitySign.class, new TileEntityRendererSign());
@@ -126,7 +126,7 @@ public class BlockEntityRenderDispatcher
     }
 
     private final Map<Class<?>, TileEntityRenderer<?>> renderers;
-    public static BlockEntityRenderDispatcher instance = new BlockEntityRenderDispatcher();
+    public static TileEntityRenderDispatcher instance = new TileEntityRenderDispatcher();
     private Font font;
     public static double renderPosX;
     public static double renderPosY;
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index bb6ced0e5..fa03f360a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -11,6 +11,8 @@ import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.weather.IPrecipitation;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
@@ -579,8 +581,15 @@ public class WorldRenderer
             }
             mc.currentScreen.setDesiredCursor(CursorShape.ARROW);
             mc.currentScreen.render(mouseX, mouseY, partialTick);
-            if (mc.currentScreen != null && mc.gameWindow.getCursorShape() != mc.currentScreen.getDesiredCursor()) {
-                mc.gameWindow.setCursorShape(mc.currentScreen.getDesiredCursor());
+
+            if (mc.currentScreen != null) {
+                CursorShape newCursor = mc.currentScreen.getDesiredCursor();
+                if(!mc.gameSettings.dynamicCursor.value) {
+                    newCursor = CursorShape.ARROW;
+                }
+                if (mc.gameWindow.getCursorShape() != newCursor) {
+                    mc.gameWindow.setCursorShape(newCursor);
+                }
             }
             if(mc.inputType == InputType.CONTROLLER && mc.currentScreen != null) {
                 mc.currentScreen.drawControllerCursor();
@@ -765,8 +774,8 @@ public class WorldRenderer
     private void addRainParticles()
     {
         Weather weather = mc.currentWorld.getCurrentWeather();
-        if (weather == null || !weather.spawnRainParticles) return;
-        
+        if (!(weather instanceof IPrecipitation) || !((IPrecipitation) weather).spawnRainParticles()) return;
+
         float f = mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower();
         
         if(mc.gameSettings.fancyGraphics.value != 1)
@@ -841,7 +850,9 @@ public class WorldRenderer
     protected void renderRainSnow(float partialTick)
     {
         Weather weather = mc.currentWorld.getCurrentWeather();
-        if (weather == null || !weather.isPrecipitation) return;
+        if (!(weather instanceof IPrecipitation)) return;
+
+        final @NotNull IPrecipitation precipitation = (IPrecipitation) weather;
         
         World world = mc.currentWorld;
         int posX = MathHelper.floor(mc.activeCamera.getX());
@@ -854,7 +865,7 @@ public class WorldRenderer
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         glAlphaFunc(516, 0.01F);
 
-        mc.textureManager.loadTexture(weather.getPrecipitationTexture(world)).bind();
+        mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.weatherManager.getWeatherPower(), world.weatherManager.getWeatherIntensity())).bind();
         
         double nextPosX = mc.activeCamera.getX(partialTick);
         double nextPosY = mc.activeCamera.getY(partialTick);
@@ -862,7 +873,7 @@ public class WorldRenderer
         int floorPosY = MathHelper.floor(nextPosY);
         int radiusEffect = 10;
 
-        if (weather.precipitationType == 1)
+        if (precipitation.getPrecipitationType() == IPrecipitation.Type.SNOW_LIKE)
         {
             for(int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
@@ -919,7 +930,7 @@ public class WorldRenderer
 
             }
         }
-        else if (weather.precipitationType == 0)
+        else if (precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE)
         {
             for(int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
@@ -966,7 +977,7 @@ public class WorldRenderer
 
             }
         }
-        else if (weather.precipitationType == 2)
+        else if (precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE)
         {
             for(int x = posX - radiusEffect; x <= posX + radiusEffect; x++)
             {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
index c25805577..1647148dd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
@@ -4,7 +4,7 @@ import net.minecraft.core.world.WorldSource;
 
 public abstract class BlockColor
 {
-    public abstract int getFallbackColor(int meta);
+    public abstract int getFallbackColor(int meta, int tintIndex);
 
-    public abstract int getWorldColor(WorldSource world, int x, int y, int z);
+    public abstract int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
index 914bcdba7..c14f23a9a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
@@ -13,7 +13,7 @@ public class BlockColorCrystal extends BlockColorCustom{
     }
     protected static ImprovedNoise crystalPerlinNoise = new ImprovedNoise(new Random(0));
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z) {
+    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
 
         int color = 0xc40e26;
 //        float offsetR = (float) (crystalPerlinNoise.getValue(x / 10f, z / 10f)) * 0.5f;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
index a0fcdb374..a0a63f884 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
@@ -16,12 +16,12 @@ public class BlockColorCustom extends BlockColor {
 	}
 	
 	@Override
-	public int getFallbackColor(int meta) {
+	public int getFallbackColor(int meta, int tintIndex) {
 		return colorizer.getDefaultColor(1.0, 0.7);
 	}
 
 	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z) {
+	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
 		return colorizer.getColor(world, x, y, z);
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
index 00083c5eb..daea781e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
@@ -6,13 +6,13 @@ public class BlockColorDefault
     extends BlockColor
 {
     @Override
-    public int getFallbackColor(int meta)
+    public int getFallbackColor(int meta, int tintIndex)
     {
         return 0xFFFFFF;
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex)
     {
         return 0xFFFFFF;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
index 337c93425..ab76b451c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
@@ -17,8 +17,8 @@ public class BlockColorLeavesOak extends BlockColorCustom {
 	}
 	
 	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z) {
-		int color = super.getWorldColor(world, x, y, z);
+	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
+		int color = super.getWorldColor(world, x, y, z, tintIndex);
 		
 		Season season = world.getSeasonManager().getCurrentSeason();
 		if(season != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java
index c616f4420..a854a0bd2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorPortal.java
@@ -5,12 +5,12 @@ import net.minecraft.core.world.WorldSource;
 
 public class BlockColorPortal extends BlockColor{
     @Override
-    public int getFallbackColor(int meta) {
+    public int getFallbackColor(int meta, int tintIndex) {
         return Colors.allPortalColors[(meta >> 4) & 0xF].getARGB();
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z) {
+    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
         return Colors.allPortalColors[(world.getBlockMetadata(x, y, z) >> 4) & 0xF].getARGB();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index ec0b2daa8..14e018f9d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -16,7 +16,7 @@ public class BlockColorTallGrass extends BlockColorCustom {
 	}
 	
 	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z) {
+	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
 
 		double localTemperature = world.getBlockTemperature(x, z);
 		double localHumidity = world.getBlockHumidity(x, z);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index f11708a46..44d929a40 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -13,19 +13,19 @@ public class BlockColorWater extends BlockColorCustom {
 	}
 	
 	@Override
-	public int getFallbackColor(int meta) {
+	public int getFallbackColor(int meta, int tintIndex) {
 		if(!mc.gameSettings.biomeWater.value || (mc.currentWorld != null && mc.currentWorld.isRetro())) {
 			return 0xFFFFFFFF;
 		}
-		return super.getFallbackColor(meta);
+		return super.getFallbackColor(meta, tintIndex);
 	}
 	
 	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z) {
+	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
 		if(!mc.gameSettings.biomeWater.value || world.isRetro()) {
 			return 0xFFFFFFFF;
 		}
-		return super.getWorldColor(world, x, y, z);
+		return super.getWorldColor(world, x, y, z, tintIndex);
 	}
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java
index 78483a675..9eea2d4f5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java
@@ -8,13 +8,13 @@ public class BlockColorWireRedstone
 {
 
     @Override
-    public int getFallbackColor(int meta)
+    public int getFallbackColor(int meta, int tintIndex)
     {
         return Colors.allRedstoneColors[15].getARGB();
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex)
     {
         // Colored by renderer
     	return Colors.allRedstoneColors[15].getARGB();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 283fbcc7a..9fe9c3bb5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -1,141 +1,47 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
 
 public abstract class BlockModel<T extends BlockLogic>
 {
-    public static RenderBlocks renderBlocks;
+    public static boolean ENABLE_DIRECTIONAL_LIGHTING = true;
+    public static final float[] SIDE_LIGHT_MULTIPLIER = {0.5f, 1.0f, 0.8f, 0.8f, 0.6f, 0.6f};
+    public static final float FULL_CUBE_THRESHOLD = 1.0f / 16.0f;
+
     public final Block<T> block;
     public BlockModel(Block<T> block){
         this.block = block;
     }
-    public abstract boolean render(Tessellator tessellator, int x, int y, int z);
-    public boolean renderNoCulling(Tessellator tessellator, int x, int y, int z) {
-        renderBlocks.renderAllFaces = true;
-        boolean result = render(tessellator, x, y, z);
-        renderBlocks.renderAllFaces = false;
-        return result;
-    }
-    public boolean renderWithOverrideTexture(Tessellator tessellator, int x, int y, int z, IconCoordinate textureIndex) {
-        renderBlocks.overrideBlockTexture = textureIndex;
-        boolean result = render(tessellator, x, y, z);
-        renderBlocks.overrideBlockTexture = null;
-        return result;
-    }
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, @Nullable Integer lightmapCoordinate){
-        renderBlockOnInventory(tessellator, metadata, brightness, 1f, lightmapCoordinate);
-    }
-    public abstract void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
+    public abstract boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z);
+    public abstract boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z);
+    public abstract boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z);
+    public abstract boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, IconCoordinate textureIndex);
+    public abstract void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
+
     public abstract boolean shouldItemRender3d();
-    public abstract float getItemRenderScale();
+    public abstract @NotNull DisplayPos getItemDisplayPos(@NotNull String id);
 
     public int renderLayer() {
         return 0;
     }
 
-    public abstract IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side);
-    public abstract IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side);
-    public abstract IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data);
-    public abstract IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data);
-    public abstract IconCoordinate getParticleTexture(Side side, int meta);
-    public abstract boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side, int meta);
-    public abstract boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side);
-    public abstract boolean shouldSideBeColored(WorldSource blockAccess, int x, int y, int z, int side, int meta);
-    public AABB getBlockBoundsForItemRender(){
-        return block.getBounds();
-    }
+    public abstract @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta);
+    public abstract @Nullable IconCoordinate getOverlayTexture(int meta);
+    public abstract int particleColorIndex(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side, int meta);
+
     public boolean hasOverbright(){
         return false;
     }
     public boolean isRetro() {
         return Minecraft.getMinecraft().currentWorld != null && Minecraft.getMinecraft().currentWorld.isRetro();
     }
-    // Everything below is utility
-    public static void setRenderBlocks(RenderBlocks rb)
-    {
-        renderBlocks = rb;
-    }
-    public void resetRenderBlocks(){
-        renderBlocks.renderAllFaces = false;
-        renderBlocks.enableAO = false;
-//        renderBlocks.overbright = false;
-        renderBlocks.useInventoryTint = true;
-        renderBlocks.flipTexture = false;
-        renderBlocks.overrideBlockTexture = null;
-        renderBlocks.uvRotateEast = 0;
-        renderBlocks.uvRotateWest = 0;
-        renderBlocks.uvRotateSouth = 0;
-        renderBlocks.uvRotateNorth = 0;
-        renderBlocks.uvRotateTop = 0;
-        renderBlocks.uvRotateBottom = 0;
-        renderBlocks.field_22352_G = 1;
-        renderBlocks.renderBitMask = 0;
-        renderBlocks.forceAO = false;
-    }
-    public void setRenderSide(Side side, boolean shouldRender){
-        if (!shouldRender){
-            renderBlocks.renderBitMask |= (byte) (1 << side.getId());
-        } else {
-            renderBlocks.renderBitMask &= (byte) ~(1 << side.getId());
-        }
-    }
-    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z){
-        return renderBlocks.getBlockBrightness(blockAccess, x, y ,z);
-    }
-
-    public final boolean renderStandardBlock(Tessellator tessellator, AABB bounds, int x, int y, int z){
-        return renderBlocks.renderStandardBlock(tessellator, this, bounds, x, y, z);
-    }
-    public final boolean renderStandardBlock(Tessellator tessellator, AABB bounds, int x, int y, int z, float r, float g, float b){
-        return renderBlocks.renderStandardBlock(tessellator, this, bounds, x, y, z, r, g, b);
-    }
-    public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, Side side, int meta){
-        return renderBlocks.renderSide(tessellator, this, bounds, x, y, z, 1, 1, 1, side, meta);
-    }
-    public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
-        return renderBlocks.renderSide(tessellator, this, bounds, x, y, z, r, g, b, side, meta);
-    }
-    public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
-                                    int dirX, int dirY, int dirZ, float depth,
-                                    int topX, int topY, int topZ, float topP, float botP,
-                                    int lefX, int lefY, int lefZ, float lefP, float rigP
-    ){
-        return renderBlocks.renderSide(tessellator, this, bounds, x, y, z, r, g, b, side, meta,
-                dirX, dirY, dirZ, depth,
-                topX, topY, topZ, topP, botP,
-                lefX, lefY, lefZ, lefP, rigP);
-    }
-
-    public final void renderBottomFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderBottomFace(tessellator, bounds, x, y, z, tex);
-    }
-
-    public final void renderTopFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderTopFace(tessellator, bounds, x, y, z, tex);
-    }
-
-    public final void renderNorthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderNorthFace(tessellator, bounds, x, y, z, tex);
-    }
-
-    public final void renderSouthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderSouthFace(tessellator, bounds, x, y, z, tex);
-    }
-
-    public final void renderWestFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderWestFace(tessellator, bounds, x, y, z, tex);
-    }
-
-    public final void renderEastFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderEastFace(tessellator, bounds, x, y, z, tex);
-    }
 }
